dhtmlxGantt с Vue.js

Это руководство предполагает, что вы обладаете базовыми знаниями о Vue и его паттернах. Если вы только начинаете работать с Vue, рекомендуем ознакомиться с документацией по Vue 3 для быстрого старта.

DHTMLX Gantt хорошо работает с Vue. Пример интеграции доступен на GitHub: DHTMLX Gantt with Vue Demo.

Создание проекта

Перед началом убедитесь, что у вас установлен Node.js.

Для создания проекта на Vue выполните команду:

npm create vue@latest

Эта команда установит и запустит create-vue, официальный инструмент для создания проектов на Vue. Подробнее см. в Vue.js Quick Start.

Установка зависимостей

Далее перейдите в директорию вашего приложения. Назовём проект gantt-vue:

cd gantt-vue

Затем установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера:

  • Для yarn выполните:
yarn install
yarn dev
  • Для npm выполните:
npm install
npm run dev

Теперь ваш проект на Vue должен быть доступен по адресу http://localhost:5173.

Gantt Vue app running

Создание Gantt

Чтобы добавить DHTMLX Gantt в проект, сначала остановите запущенное приложение, нажав Ctrl+C в терминале. Затем перейдите к установке пакета Gantt.

Шаг 1. Установка пакета

PRO-версии библиотеки можно установить через npm/yarn из нашего приватного репозитория. Следуйте этой инструкции для получения доступа.

После получения Evaluation-версии установите её одной из следующих команд:

  • Через npm:
npm install @dhx/trial-gantt
  • Через yarn:
yarn add @dhx/trial-gantt

Либо, так как zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте Vue-компонент для внедрения Gantt в ваше приложение. Добавьте новый файл Gantt.vue в директорию src/components/.

Импорт исходных файлов

Откройте Gantt.vue и импортируйте исходные файлы Gantt. Обратите внимание на различие в зависимости от способа установки:

  • Если вы устанавливали из локальной папки, используйте:

Gantt.vue

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Если вы устанавливали trial-версию, используйте:

Gantt.vue

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

В этом руководстве используется trial-версия.

Задание контейнера и добавление Gantt

Чтобы отобразить Gantt на странице, укажите элемент-контейнер. Пример:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

Чтобы контейнер Gantt занимал всю площадь body, удалите стандартные стили из main.css в src/assets и добавьте:

src/assets/main.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Шаг 3. Добавление Gantt в приложение

Далее подключите компонент Gantt в вашем приложении. Откройте src/App.vue и замените содержимое на:

src/App.vue

<script>
import Gantt from "./components/Gantt.vue";
 
export default {
  components: { Gantt }
};
</script>   <template> <Gantt/> </template>

После запуска приложения вы увидите пустой Gantt:

Gantt Vue init

Шаг 4. Передача данных

Чтобы отобразить задачи в Gantt, передайте набор данных. Создайте файл data.js в директории src/ со следующим содержимым:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Передайте эти данные как props в компонент Gantt в App.vue:

App.vue

<script>
import Gantt from "./components/Gantt.vue";
import { getData } from "./data";
 
export default {
  components: { Gantt },
  data() {
    return {
      tasks: getData(),
    };
  },
};
</script>   <template> <Gantt :tasks="tasks" /> </template>

Затем используйте эти props с gantt.parse() в компоненте Gantt:

Gantt.vue

<script>
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default {
  props: ["tasks"],
 
  mounted() {
    let gantt = Gantt.getGanttInstance();
    gantt.init(this.$refs.cont);
    gantt.parse(this.tasks);
 
    this.gantt = gantt;
  },
  unmounted() {
    this.gantt.destructor();
    this.$refs.cont.innerHTML = "";
  },
};
</script>   <template> <div ref="cont" style="width: 100%; height: 100%"></div> </template>

После перезагрузки страницы приложения вы увидите Gantt с задачами:

Gantt tasks

Шаг 5. Сохранение данных

Для отслеживания изменений в Gantt используйте обработчик dataProcessor, который управляет связью с вашим backend. Такой обработчик может быть функцией или объектом router. dhtmlxGantt поддерживает Promise-ответы от обработчика, что гарантирует корректную обработку завершения действий.

Создайте DataProcessor с помощью createDataProcessor() и отслеживайте изменения следующим образом:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Если ваш backend изменяет идентификаторы задач после создания новых записей (что часто встречается в различных системах), убедитесь, что ваш Promise возвращает объект вида {id: databaseId} или {tid: databaseId}. Это позволит Gantt обновить запись с новым ID из базы данных. Подробности см. в разделе интеграция с сервером.

Теперь ваша интеграция Vue и Gantt завершена. Вы можете ознакомиться с полной демонстрацией на GitHub: https://github.com/DHTMLX/vue-gantt-demo.

XSS, CSRF и SQL-инъекции

Обратите внимание, что сам Gantt не защищает от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Ответственность за безопасность приложения лежит на backend-разработчиках.

Обратитесь к статье Безопасность приложения, чтобы узнать о типовых уязвимостях и способах усиления защиты вашего приложения.

К началу

dhtmlxGantt с Angular

Это руководство предполагает базовое понимание концепций и паттернов Angular. Если вам нужно освежить знания, ознакомьтесь с документацией Angular, где есть полезный вводный туториал.

DHTMLX Gantt отлично работает с Angular. Пример интеграции можно найти на GitHub: DHTMLX Gantt with Angular Demo.

Создание проекта

Перед созданием нового проекта убедитесь, что у вас установлены Angular CLI и Node.js.

ng new my-angular-gantt-app

Эта команда установит все необходимые инструменты и зависимости, дополнительных команд установки не требуется.

Установка зависимостей

Далее перейдите в директорию вашего приложения:

cd my-angular-gantt-app

Запустите приложение с помощью одной из команд:

yarn start

или

npm start

Теперь ваше приложение будет доступно по адресу http://localhost:4200.

Gantt Angular app running

Создание Gantt

Следующий шаг — получить код DHTMLX Gantt. Сначала остановите приложение, нажав Ctrl+C в командной строке, затем установите пакет Gantt.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Следуйте этой инструкции для получения доступа.

Когда у вас будет Evaluation-версия Gantt, установите её одной из следующих команд:

  • для npm:
npm install @dhx/trial-gantt
  • для yarn:
yarn add @dhx/trial-gantt

Также, так как zip-пакет структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Создайте компонент для интеграции Gantt в ваше приложение. Начните с создания папки gantt внутри директории src/app/. Добавьте два файла: gantt.component.ts и gantt.component.css.

Импорт исходных файлов

Откройте gantt.component.ts и импортируйте исходные файлы Gantt. Обратите внимание на разницу в зависимости от способа установки:

  • Если установлен из локальной папки, импорты выглядят так:

gantt.component.ts

import { Gantt } from 'dhtmlx-gantt';

gantt.component.css

@import "@dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Если используется trial-версия, импорты должны быть такими:

gantt.component.ts

import { Gantt } from '@dhx/trial-gantt';

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

В этом руководстве используется trial-версия.

Файл gantt.component.ts будет служить шаблоном для компонента Gantt. Добавьте следующий код:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.init(this.ganttContainer.nativeElement);
 
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

Здесь метод ngOnInit() инициализирует Gantt, а ngOnDestroy() выполняет очистку, вызывая gantt.destructor() при удалении компонента.

Стили для Gantt размещаются в gantt.component.css. Пример базовой настройки стилей:

gantt.component.css

@import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
.gantt-chart {
    position: relative;
    width: 100%;
    height: 600px;
}

Шаг 3. Добавление Gantt в приложение

Далее добавьте компонент Gantt в приложение. Откройте src/app/app.component.ts и замените содержимое на:

src/app/app.component.ts

import { Component } from '@angular/core';
 
@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = 'DHTMLX Gantt with Angular';
}

Создайте app.module.ts в src/app/ и подключите GanttComponent следующим образом:

src/app/app.module.ts

import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
 
import { AppComponent } from "./app.component";
import { GanttComponent } from './gantt/gantt.component';
 
@NgModule({
  declarations: [AppComponent, GanttComponent],
  imports: [BrowserModule],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}

В файле src/app/app.component.html замените содержимое на:

src/app/app.component.html

<gantt></gantt>

Наконец, обновите src/main.ts, заменив его содержимое на:

src/main.ts

import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
 
platformBrowserDynamic()
  .bootstrapModule(AppModule)
  .catch((err) => console.error(err));

Теперь при запуске приложения должен отобразиться пустой график Gantt:

Gantt Angular init

Шаг 4. Загрузка данных

Чтобы загрузить данные в Angular Gantt, необходимо добавить сервисы для задач и связей. Прежде чем это сделать, определите модели задач и связей.

Создайте модели задач и связей следующими командами:

ng generate class models/task --skip-tests
ng generate class models/link --skip-tests

В файле models/task.ts добавьте:

models/task.ts

export class Task {
    id!: number;
    start_date!: string;
    text!: string;
    progress!: number;
    duration!: number;
    parent!: number;
}

В файле models/link.ts добавьте:

models/link.ts

export class Link {
     id!: number;
    source!: number;
    target!: number;
    type!: string;
}

Теперь создайте сервисы задач и связей. Сервисы в Angular — это классы, отвечающие за выполнение определённых задач или функций, которые можно внедрять в нужные компоненты.

Создайте сервисы командами:

ng generate service services/task --flat --skip-tests
ng generate service services/link --flat --skip-tests

В файле services/task.service.ts добавьте:

services/task.service.ts

import { Injectable } from '@angular/core';
import { Task } from '../models/task';
 
@Injectable()
export class TaskService {
    get(): Promise<Task[]>{
        return Promise.resolve([
            { id: 1, text: 'Task #1', start_date: '2023-04-15 00:00', 
                duration: 3, progress: 0.6, parent: 0 },
            { id: 2, text: 'Task #2', start_date: '2023-04-18 00:00', 
                duration: 3, progress: 0.4, parent: 0 }
        ]);
    }
}

В файле services/link.service.ts добавьте:

services/link.service.ts

import { Injectable } from '@angular/core';
import { Link } from '../models/link';
 
@Injectable()
export class LinkService {
    get(): Promise<Link[]> {
        return Promise.resolve([
            { id: 1, source: 1, target: 2, type: '0' }
        ]);
    }
}

Декоратор @Injectable() позволяет сервисам создаваться системой внедрения зависимостей Angular. Методы get() сейчас возвращают захардкоженные данные в промисах, но их можно адаптировать для получения данных с сервера.

Чтобы использовать эти сервисы в компоненте Gantt, импортируйте их в gantt.component.ts:

gantt.component.ts

import {TaskService} from "../services/task.service";
import {LinkService} from "../services/link.service";

Добавьте сервисы в провайдеры декоратора @Component:

gantt.component.ts

@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})

Это гарантирует создание нового экземпляра каждого сервиса для каждого нового GanttComponent.

Добавьте конструктор для внедрения сервисов:

gantt.component.ts

constructor(private taskService: TaskService, private linkService: LinkService) { }

Обновите ngOnInit(), чтобы настроить формат даты, инициализировать Gantt и загрузить данные из сервисов:

gantt.component.ts

let gantt = Gantt.getGanttInstance();
gantt.config.date_format = '%Y-%m-%d %H:%i';
gantt.init(this.ganttContainer.nativeElement);
 
Promise.all([this.taskService.get(), this.linkService.get()])
    .then( ([data, links]) => {
        gantt.parse({ data, links });
    });
this._gantt = gantt;

Полный файл gantt.component.ts будет выглядеть так:

gantt.component.ts

import { Component, ElementRef, OnInit, 
    ViewChild, ViewEncapsulation } from '@angular/core';
import { TaskService } from '../services/task.service';
import { LinkService } from '../services/link.service';
import { Gantt, GanttStatic } from "@dhx/trial-gantt";
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'gantt',
    styleUrls: ['./gantt.component.css'],
    providers: [TaskService, LinkService],
    template: `<div #gantt_here class='gantt-chart'></div>`,
})
export class GanttComponent implements OnInit {
    @ViewChild('gantt_here', { static: true }) ganttContainer!: ElementRef;
    private _gantt?: GanttStatic;
    constructor(private taskService: TaskService, private linkService: LinkService) { }
 
    ngOnInit() {
        let gantt = Gantt.getGanttInstance();
        gantt.config.date_format = '%Y-%m-%d %H:%i';
        gantt.init(this.ganttContainer.nativeElement);
        Promise.all([this.taskService.get(), this.linkService.get()])
            .then(([data, links]) => {
                gantt.parse({ data, links });
            });
        this._gantt = gantt;
    }
    ngOnDestroy() {
        if (this._gantt) this._gantt.destructor();
    }
}

После перезагрузки страницы приложения вы увидите Gantt с загруженными задачами:

Gantt Angular events

Шаг 5. Сохранение данных

Для отслеживания изменений в Gantt вы можете использовать обработчик dataProcessor, который позволяет взаимодействовать с серверной частью. Этот обработчик можно настроить как функцию или как объект-роутер. dhtmlxGantt поддерживает возврат Promise из обработчика, что позволяет корректно обрабатывать завершение действия.

Создать DataProcessor можно с помощью метода createDataProcessor() API и отслеживать изменения следующим образом:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Если ваш сервис меняет id задачи после добавления новой записи (что обычно бывает), убедитесь, что ваш Promise возвращает объект с {id: databaseId} или {tid: databaseId}. Это позволит Gantt обновить запись с новым id из базы данных. Подробнее см. информацию о серверной части.

Теперь ваш Angular Gantt полностью готов. Вы также можете посмотреть полный демо-пример на GitHub.

XSS, CSRF и SQL-инъекции

Обратите внимание, что сам Gantt не обеспечивает защиту от таких угроз, как SQL-инъекции, XSS или CSRF-атаки. За безопасность приложения отвечает команда разработчиков серверной части.

Ознакомьтесь со статьёй Application Security, чтобы узнать о наиболее уязвимых местах компонента и о шагах, которые можно предпринять для повышения безопасности вашего приложения.

К началу

dhtmlxGantt с React

Этот учебник демонстрирует, как использовать JS DHTMLX Gantt в React-приложениях. Для официального компонента React Gantt, пожалуйста, смотрите статью React Gantt.

Перед началом работы с этим руководством рекомендуется иметь базовое понимание концепций и паттернов React. Если вы новичок в React, ознакомьтесь с документацией по React для получения вводной информации.

DHTMLX Gantt хорошо работает с React. Пример можно найти на GitHub: DHTMLX Gantt with React Demo.

Создание проекта

Перед созданием нового проекта убедитесь, что у вас установлен Node.js.

Для быстрой инициализации базового React-проекта выполните следующую команду:

npx create-vite my-react-gantt-app --template react

Установка зависимостей

Далее перейдите в папку вашего проекта. Если ваш проект называется my-react-gantt-app, выполните:

cd my-react-gantt-app

Затем установите зависимости и запустите сервер разработки. В зависимости от выбранного менеджера пакетов используйте:

  • с yarn:
yarn install
yarn dev
  • с npm:
npm install
npm run dev

Ваше React-приложение теперь должно быть доступно по адресу http://localhost:5173.

Gantt React app running

Создание Gantt

Далее получим код DHTMLX Gantt. Сначала остановите запущенное приложение, нажав Ctrl+C в терминале. Затем установите пакет Gantt.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Пожалуйста, следуйте этой инструкции для получения доступа.

После получения Evaluation-версии установите её с помощью следующих команд:

  • для npm:
npm install @dhx/trial-gantt
  • для yarn:
yarn add @dhx/trial-gantt

Кроме того, поскольку zip-пакет библиотеки структурирован как модуль npm, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Теперь создайте React-компонент для интеграции Gantt в ваше приложение. Добавьте новый файл с именем Gantt.jsx в директорию src/.

Импорт исходных файлов

Откройте Gantt.jsx и импортируйте исходные файлы Gantt. Обратите внимание:

  • Если вы устанавливали Gantt из локальной папки, ваши импорты будут выглядеть так:

Gantt.jsx

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Если вы устанавливали trial-версию, используйте такие импорты:

Gantt.jsx

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

В этом руководстве используется trial версия.

Установка контейнера и добавление Gantt

Чтобы отобразить Gantt на странице, требуется элемент-контейнер. Файл Gantt.jsx должен содержать следующее:

Gantt.jsx

import { useEffect, useRef } from "react"; import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView() {   let container = useRef();  
  useEffect(() => {     let gantt = Gantt.getGanttInstance();     gantt.init(container.current);  
    return () => {       gantt.destructor();       container.current.innerHTML = "";     };   }, []);  
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>; }

Шаг 3. Добавление Gantt в приложение

Теперь включите компонент Gantt в ваше приложение. Откройте src/app.jsx и замените содержимое на следующее:

src/app.jsx

import Gantt from "./Gantt";
 
function App() {
  return <Gantt/>;
}
 
export default App;

Чтобы контейнер Gantt занимал всю область, удалите стандартные стили из index.css в папке src/ и добавьте:

src/index.css

html,
body,
#root {
  height: 100%;
  padding: 0;
  margin: 0;
}

При повторном запуске приложения вы увидите пустую диаграмму Gantt на странице:

Gantt React init

Шаг 4. Передача данных

Чтобы отобразить задачи в Gantt, предоставьте набор данных. Создайте файл data.js в src/ со следующим содержимым:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Передайте эти данные как props в компонент Gantt в App.jsx:

App.jsx

import Gantt from "./Gantt";
import { getData } from "./data.js";
 
function App() {
  return <Gantt tasks={getData()} />;
}
 
export default App;

Затем используйте props внутри метода gantt.parse() в компоненте Gantt:

Gantt.jsx

import { useEffect, useRef } from "react";
import { Gantt } from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
 
export default function GanttView(props) {
  let container = useRef();
 
  useEffect(() => {
    let gantt = Gantt.getGanttInstance();
    gantt.init(container.current);
    gantt.parse(props.tasks);  
    return () => {
      gantt.destructor();
      container.current.innerHTML = "";
    };
  }, []);
 
  return <div ref={container} style={ {width: "100%", height: "100%"} }></div>;
}

После перезагрузки приложения диаграмма Gantt отобразит задачи:

Gantt tasks

Шаг 5. Сохранение данных

Для обработки изменений в Gantt вы можете использовать dataProcessor, который позволяет взаимодействовать с вашим backend. dataProcessor может быть определён как функция или объект router. dhtmlxGantt поддерживает Promise-ответы от обработчика, что позволяет корректно обрабатывать действия.

Создайте DataProcessor с помощью createDataProcessor() и слушайте изменения следующим образом:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Если ваш backend присваивает новый id после создания записи (это распространённое поведение), убедитесь, что Promise возвращает объект с {id: databaseId} или {tid: databaseId}, чтобы Gantt мог обновить запись. Подробнее в разделе server side integration.

На этом настройка React Gantt завершена. Вы можете ознакомиться с полной демонстрацией на GitHub: https://github.com/DHTMLX/react-gantt-demo.

XSS, CSRF и SQL-инъекции

Имейте в виду, что сам Gantt не обеспечивает защиту от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Обеспечение безопасности приложения — ответственность разработчиков backend.

Смотрите статью Application Security для ознакомления с типовыми уязвимостями и рекомендациями по повышению безопасности вашего приложения.

К началу

dhtmlxGantt с Svelte

Данное руководство предполагает, что вы обладаете базовыми знаниями о концепциях и паттернах Svelte. Если нет, вы можете ознакомиться с полезным вводным руководством в документации Svelte.

DHTMLX Gantt отлично работает с Svelte. Ознакомиться с рабочим примером можно на GitHub: DHTMLX Gantt with Svelte Demo.

Создание проекта

Перед началом работы рекомендуется установить Vite (необязательно) и Node.js.

Для создания проекта Svelte мы воспользуемся Vite. Выполните команду:

npm create vite@latest

Подробнее об этом можно узнать в соответствующей статье.

Установка зависимостей

Далее перейдите в директорию вашего приложения. Назовём проект gantt-svelte и выберем опцию svelte. Затем выполните:

cd gantt-svelte

Теперь установите зависимости и запустите приложение с помощью предпочитаемого пакетного менеджера:

  • Для yarn выполните:
yarn install
yarn dev
  • Для npm выполните:
npm install
npm run dev

Ваш Svelte-проект теперь будет доступен по адресу http://localhost:5173.

Gantt Svelte app running

Создание Gantt

Для добавления DHTMLX Gantt сначала остановите приложение, нажав Ctrl+C в терминале. Затем приступайте к установке пакета Gantt.

Шаг 1. Установка пакета

PRO-версии библиотеки доступны через npm/yarn из нашего приватного репозитория. Пожалуйста, следуйте этой инструкции для получения доступа.

После получения Evaluation-версии установите её с помощью:

  • Для npm:
npm install @dhx/trial-gantt
  • Для yarn:
yarn add @dhx/trial-gantt

Альтернативно, так как zip-пакет библиотеки структурирован как npm-модуль, вы можете установить его из локальной папки.

Шаг 2. Создание компонента

Далее создайте Svelte-компонент для включения Gantt в ваше приложение. Добавьте новый файл Gantt.svelte в папку src/.

Импорт исходных файлов

Откройте Gantt.svelte и импортируйте исходные файлы Gantt. Обратите внимание:

  • Если вы устанавливали пакет Gantt из локальной папки, ваши импорты будут выглядеть так:

Gantt.svelte

import { Gantt} from "dhtmlx-gantt";
import "dhtmlx-gantt/codebase/dhtmlxgantt.css";
  • Если установлена trial-версия, используйте такие импорты:

Gantt.svelte

import { Gantt} from "@dhx/trial-gantt";
import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";

В этом руководстве используется trial-версия.

Задание контейнера и добавление Gantt

Чтобы отобразить Gantt на странице, определите контейнер для рендеринга компонента. Пример:

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

Чтобы контейнер Gantt занимал всё тело страницы, удалите стандартные стили из app.css в папке src/ и добавьте:

src/app.css

body, #app {
  margin: 0;
  padding: 0;
  height: 100vh;
  width: 100%;
}

Шаг 3. Добавление Gantt в приложение

Теперь подключите компонент Gantt в приложении. Откройте src/App.svelte и замените содержимое на:

src/App.svelte

<script>
  import Gantt from "./Gantt.svelte";
</script>
 
<Gantt/>

Теперь при запуске приложения должен отображаться пустой график Gantt:

Gantt Svelte init

Шаг 4. Передача данных

Чтобы заполнить Gantt, передайте данные. Создайте файл data.js в src/ и добавьте:

src/data.js

export function getData() {
  const tasks = {
    data: [
      {
        id: "10",
        text: "Project #1",
        start_date: "01-04-2025",
        duration: 3,
        order: 10,
        progress: 0.4,
        open: true,
      },
      {
        id: "1",
        text: "Task #1",
        start_date: "01-04-2025",
        duration: 1,
        order: 10,
        progress: 0.6,
        parent: "10",
      },
      {
        id: "2",
        text: "Task #2",
        start_date: "02-04-2025",
        duration: 2,
        order: 20,
        progress: 0.6,
        parent: "10",
      },
    ],
    links: [{ id: 1, source: 1, target: 2, type: "0" }],
  };
  return tasks;
}

Передайте эти данные как пропсы в компонент Gantt в App.svelte:

App.svelte

<script>
  import Gantt from "./Gantt.svelte";
  import { getData } from "./data.js";
</script>   <Gantt tasks={getData()} />

Далее используйте пропсы внутри компонента Gantt с помощью gantt.parse():

Gantt.svelte

<script>
    import "@dhx/trial-gantt/codebase/dhtmlxgantt.css";
    import { onMount } from "svelte";
    import { Gantt } from "@dhx/trial-gantt";
 
    export let tasks;
 
    let container;
    onMount(() => {
        let gantt = Gantt.getGanttInstance();
        gantt.init(container);
        gantt.parse(tasks);
 
        return () => {
            gantt.destructor();
        };
    });
</script>   <div bind:this={container} style="width: 100%; height: 100%;"></div>

После перезагрузки приложения должен появиться график Gantt с задачами:

Gantt tasks

Шаг 5. Сохранение данных

Для отслеживания изменений в Gantt вы можете использовать обработчик dataProcessor. Он облегчает взаимодействие с сервером и может быть определён как функция или объект роутера. dhtmlxGantt поддерживает Promise-ответы, что обеспечивает корректную обработку действий.

Создайте DataProcessor с помощью createDataProcessor() для отслеживания изменений следующим образом:

gantt.createDataProcessor(function(entity, action, data, id) {​
    gantt.message(`${​entity} ${​action}`);
});

Если ваш сервер изменяет идентификаторы задач после создания новых записей, убедитесь, что Promise возвращает объект с {id: databaseId} или {tid: databaseId}, чтобы Gantt мог обновить соответствующую запись. Подробнее о серверной интеграции читайте здесь.

На этом настройка Svelte Gantt завершена. Вы можете ознакомиться с полным демо на GitHub: https://github.com/DHTMLX/svelte-gantt-demo.

XSS, CSRF и SQL Injection атаки

Обратите внимание, что Gantt не содержит встроенных средств защиты от угроз, таких как SQL-инъекции, XSS или CSRF-атаки. Обеспечение безопасности приложения от подобных рисков лежит на разработчиках серверной части.

Для получения информации о потенциальных уязвимостях и рекомендациях по безопасности обратитесь к статье Application Security.

К началу